## scram 0.11.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

# In-source build prevention.
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(STATUS "SCRAM requires an out-of-source build.")
  message(STATUS "Please remove these files from ${CMAKE_BINARY_DIR} first:")
  message(STATUS "CMakeCache.txt")
  message(STATUS "CMakeFiles")
  message(STATUS "Once these files are removed, create a separate directory")
  message(STATUS "and run CMake from there.")
  message(FATAL_ERROR "in-source build detected")
endif()

project(SCRAM)
set(SCRAM_VERSION_MAJOR 0)  # Indicate major API change after 1.0.0
set(SCRAM_VERSION_MINOR 11)  # New features and improvements.
set(SCRAM_VERSION_MICRO 4)  # Bug fixes.

####################### Begin Options ###################

set(BUILD_SHARED_LIBS TRUE)  # Change this for static building.

# Linking of external libraries, such as BOOST.
option(WITH_STATIC_LIBS "Try to link against static libraries" OFF)

option(WITH_TCMALLOC "Use TCMalloc" ON)

option(WITH_COVERAGE "Instrument for coverage analysis" OFF)
option(WITH_PROFILE "Instrument for performance profiling" OFF)

option(BUILD_GUI "Build the GUI front-end" ON)
option(BUILD_TESTS "Build the tests" ON)

option(PACKAGE "Package for distribution" OFF)

####################### End Options ###################

####################### Begin compiler configurations ###################

# Default to C++14.
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++1y" COMPILER_SUPPORTS_CXX14)
if(NOT COMPILER_SUPPORTS_CXX14)
  message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support.")
endif()
add_definitions("-std=c++1y")

set(CMAKE_CXX_FLAGS_DEBUG
  "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -Wno-sign-compare -Wnon-virtual-dtor -Wno-missing-field-initializers")

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wpedantic")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wshadow -Wsuggest-override")
  endif()
  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6)
    # TODO: Boost sign bit shift fails to compile on GCC 6.1
    add_definitions("-fpermissive")
  endif()

elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
  set(CMAKE_CXX_FLAGS_DEBUG
    "${CMAKE_CXX_FLAGS_DEBUG} -Wno-missing-braces -Wshadow -Wunused-exception-parameter")

elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  # TODO: Bug in Intel compiler with multi-initialization with auto.
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=3373")
  # TODO: Bug in Intel compiler w/o GCC 5 built-in math with overlflow.
  add_definitions(-D_GLIB_TEST_OVERFLOW_FALLBACK)  # TODO: Remove after glib2 version 2.48
endif()

if(WIN32)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-error")
endif()

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)

  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
     "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
    add_definitions("-Qunused-arguments")  # TODO: CCache bug with not splitting args.
  endif()
endif()

######################## End compiler configurations ####################

##################### Begin cmake configuration ###################

# Set project directories.
set(PROJECT_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
set(SCRAM_SOURCE_DIR "${PROJECT_SOURCE_DIR}/src")
set(SCRAM_GUI_DIR "${PROJECT_SOURCE_DIR}/gui")
set(SCRAM_SHARE_DIR "${PROJECT_SOURCE_DIR}/share")
set(SCRAM_TEST_DIR "${PROJECT_SOURCE_DIR}/tests")
set(SCRAM_INPUT_DIR "${PROJECT_SOURCE_DIR}/input")

# Setup build locations.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/bin")
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib")
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib")
endif()

set(SCRAM_EXECUTABLE_DIR "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

# Use, i.e. don't skip the full RPATH for the build tree.
set(CMAKE_SKIP_BUILD_RPATH FALSE)

# When building,
# don't use the install RPATH already
# (but later on when installing).
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# Add the automatically determined parts of the RPATH,
# which point to directories outside the build tree
# to the install RPATH.
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# Tell CMake where the modules are.
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

######################## End cmake configuration ###################

######################## Begin find libraries ######################

set(LIBS "")

# Optional TCMalloc for optimization.
if(WITH_TCMALLOC AND NOT WITH_PROFILE)
  find_package(Tcmalloc)
  set(LIBS ${LIBS} ${Tcmalloc_LIBRARIES})
endif()

# Find LibXML++ and dependencies.
set(LIBXML++_MIN_VERSION "2.38.1")  # TODO: Fix the minimum version check.
find_package(LibXML++ "${LIBXML++_MIN_VERSION}" REQUIRED)
set(LIBS ${LIBS} ${LibXML++_LIBRARIES})

message(STATUS ${LIBS})

# Include the boost header files and the program_options library.
# Please be sure to use Boost rather than BOOST.
# Capitalization matters on some platforms.
set(BOOST_MIN_VERSION "1.56.0")
set(Boost_USE_STATIC_LIBS ${WITH_STATIC_LIBS})
set(Boost_USE_STATIC_RUNTIME ${WITH_STATIC_LIBS})

if(NOT WIN32)
  set(Boost_USE_MULTITHREADED OFF)
endif()

unset(Boost_INCLUDE_DIR CACHE)
unset(Boost_LIBRARY_DIRS CACHE)
find_package(Boost ${BOOST_MIN_VERSION} COMPONENTS
  program_options filesystem system date_time
  REQUIRED)

if(Boost_USE_STATIC_LIBS)
  message(STATUS "Linking against boost static libraries")
else()
  message(STATUS "Linking against boost dynamic libraries")
endif()

if(Boost_ROOT)
  message(STATUS "    Boost Root: ${Boost_ROOT}")
endif()
message(STATUS "    Boost Include directory: ${Boost_INCLUDE_DIR}")
message(STATUS "    Boost Library directories: ${Boost_LIBRARY_DIRS}")

set(LIBS ${LIBS} ${Boost_PROGRAM_OPTIONS_LIBRARY})
message(STATUS "    Boost Program Options location: ${Boost_PROGRAM_OPTIONS_LIBRARY}")
set(LIBS ${LIBS} ${Boost_SYSTEM_LIBRARY})
message(STATUS "    Boost System location: ${Boost_SYSTEM_LIBRARY}")
set(LIBS ${LIBS} ${Boost_FILESYSTEM_LIBRARY})
message(STATUS "    Boost Filesystem location: ${Boost_FILESYSTEM_LIBRARY}")
set(LIBS ${LIBS} ${Boost_DATE_TIME_LIBRARY})
message(STATUS "    Boost Date-Time location: ${Boost_DATE_TIME_LIBRARY}")

if(BUILD_GUI)
  # Find the QtWidgets library.
  if(APPLE)
    # Qt5 with Homebrew.
    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "/usr/local/opt/qt5")
  endif()
  find_package(Qt5Widgets REQUIRED)
  if(Qt5Widgets_FOUND)
    message(STATUS "Found Qt5")
    message(STATUS "Qt5 Version: ${Qt5Widgets_VERSION_STRING}")
  endif()
endif()

########################## End of find libraries ########################

########################## Begin includes ###############################

# Include all the discovered system directories.
include_directories(SYSTEM "${Boost_INCLUDE_DIR}")
include_directories(SYSTEM "${LIBXML2_INCLUDE_DIR}")  # TODO: libxml++ dependency.
include_directories(SYSTEM "${LibXML++_INCLUDE_DIR}")
include_directories(SYSTEM "${LibXML++Config_INCLUDE_DIR}")
include_directories(SYSTEM ${Glibmm_INCLUDE_DIRS})  # TODO: libxml++ dependency.

add_subdirectory("${SCRAM_SOURCE_DIR}")
add_subdirectory("${SCRAM_SHARE_DIR}")
add_subdirectory("${SCRAM_INPUT_DIR}")

if(BUILD_GUI)
  add_subdirectory("${SCRAM_GUI_DIR}")
endif()

if(BUILD_TESTS)
  add_subdirectory("${SCRAM_TEST_DIR}")
endif()

####################### End includes ####################################

###################### Begin uninstall target ###########################

configure_file(
  "${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY
  )

add_custom_target(uninstall
  COMMAND "${CMAKE_COMMAND}" -P "\"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake\"")

###################### End uninstall target #############################

###################### Begin CPACK configurations ###########################

if(PACKAGE)
  if(WIN32)
    set(CPACK_GENERATOR "NSIS")
    # TODO: Find a way to programmatically detect shared libraries and add to installation.
    # The following configuration assumes MinGW64 is setup specifically for this project.
    get_filename_component(MINGW_DLL_DIR "${CMAKE_CXX_COMPILER}" PATH)
    message(STATUS "MinGW bin location: ${MINGW_DLL_DIR}")
    file(GLOB all_libs "${MINGW_DLL_DIR}/lib*.dll")
    install(FILES
      ${all_libs}
      ${MINGW_DLL_DIR}/zlib1.dll
      DESTINATION bin COMPONENT libraries
    )

    # Qt Libraries
    install(FILES
      ${MINGW_DLL_DIR}/Qt5Core.dll
      ${MINGW_DLL_DIR}/Qt5Gui.dll
      ${MINGW_DLL_DIR}/Qt5Widgets.dll
      DESTINATION bin COMPONENT libraries
    )
  endif()
endif()

set(CPACK_PACKAGE_VENDOR "Olzhas Rakhimov")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Probabilistic risk analysis tool")
set(CPACK_PACKAGE_VERSION_MAJOR "${SCRAM_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${SCRAM_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${SCRAM_VERSION_MICRO}")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")

set(CPACK_COMPONENTS_ALL scram libraries gui examples)
set(CPACK_COMPONENT_SCRAM_REQUIRED ON)
set(CPACK_COMPONENT_LIBRARIES_REQUIRED ON)

include(CPack)

###################### End CPACK configurations #############################

=== tests/CMakeLists.txt ===
find_package(Qt5Test REQUIRED)

macro(TEST NAME FILE)
  add_executable(${NAME} ${FILE})
  target_link_libraries(${NAME} Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Test)
  add_test(NAME ${NAME} COMMAND  $<TARGET_FILE:${NAME}>)
endmacro()

enable_testing()

TEST(TestDummy testdummy.cpp)

add_custom_target(gui_tests COMMAND ${CMAKE_CTEST_COMMAND}
  DEPENDS
  TestDummy
)

=== translations/CMakeLists.txt ===
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)  # prevent 'make clean'

find_package(Qt5LinguistTools)

if(Qt5LinguistTools_FOUND)
  message(STATUS "Found Qt5 Linguist")
  set(SCRAM_GUI_TS "${CMAKE_CURRENT_SOURCE_DIR}/scram_untranslated.ts")

  qt5_add_translation(SCRAM_GUI_QM ${SCRAM_GUI_TS})
  set(TRANSLATIONS ${SCRAM_GUI_QM} PARENT_SCOPE)
  add_custom_target(translations ALL DEPENDS ${TRANSLATIONS})

  install(FILES ${TRANSLATIONS} DESTINATION share/scram/translations)

  qt5_create_translation(TRANSLATION_MESSAGES "${SCRAM_GUI_DIR}" ${SCRAM_GUI_TS})
  add_custom_target(translations_update DEPENDS ${TRANSLATION_MESSAGES})
endif()

=== debian/changelog ===
scram (0.11.4-1) unstable; urgency=low

  * Initial Debian Package (Closes: #842766)

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Tue, 06 Dec 2016 11:27:56 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_PREPEND = -Wl,-z,defs -Wl,--as-needed

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_GUI=OFF \
		-DBUILD_TESTS=OFF

%:
	dh $@ --buildsystem=cmake

## scram 0.11.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,16 +14,19 @@
 project(SCRAM)
 set(SCRAM_VERSION_MAJOR 0)  # Indicate major API change after 1.0.0
 set(SCRAM_VERSION_MINOR 11)  # New features and improvements.
-set(SCRAM_VERSION_MICRO 4)  # Bug fixes.
+set(SCRAM_VERSION_MICRO 5)  # Bug fixes.
 
 ####################### Begin Options ###################
 
-set(BUILD_SHARED_LIBS TRUE)  # Change this for static building.
+option(BUILD_SHARED_LIBS OFF)
+
+option(INSTALL_LIBS "Install the generated libraries" ON)
 
 # Linking of external libraries, such as BOOST.
 option(WITH_STATIC_LIBS "Try to link against static libraries" OFF)
 
-option(WITH_TCMALLOC "Use TCMalloc" ON)
+option(WITH_TCMALLOC "Use TCMalloc if available (#1 preference)" ON)
+option(WITH_JEMALLOC "Use JEMalloc if available (#2 preference)" ON)
 
 option(WITH_COVERAGE "Instrument for coverage analysis" OFF)
 option(WITH_PROFILE "Instrument for performance profiling" OFF)
@@ -43,7 +46,7 @@
 if(NOT COMPILER_SUPPORTS_CXX14)
   message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support.")
 endif()
-add_definitions("-std=c++1y")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y")
 
 set(CMAKE_CXX_FLAGS_DEBUG
   "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -Wno-sign-compare -Wnon-virtual-dtor -Wno-missing-field-initializers")
@@ -66,8 +69,6 @@
 elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
   # TODO: Bug in Intel compiler with multi-initialization with auto.
   set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=3373")
-  # TODO: Bug in Intel compiler w/o GCC 5 built-in math with overlflow.
-  add_definitions(-D_GLIB_TEST_OVERFLOW_FALLBACK)  # TODO: Remove after glib2 version 2.48
 endif()
 
 if(WIN32)
@@ -76,6 +77,7 @@
 
 find_program(CCACHE_FOUND ccache)
 if(CCACHE_FOUND)
+  message(STATUS "Using CCache for builds")
   set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
   set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
 
@@ -118,7 +120,9 @@
 # (but later on when installing).
 set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
 
-set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+if(INSTALL_LIBS)
+  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+endif()
 
 # Add the automatically determined parts of the RPATH,
 # which point to directories outside the build tree
@@ -132,13 +136,20 @@
 
 ######################## Begin find libraries ######################
 
-set(LIBS "")
-
-# Optional TCMalloc for optimization.
-if(WITH_TCMALLOC AND NOT WITH_PROFILE)
+set(MALLOC "System Malloc")
+# Optional alternative Malloc for optimization.
+if(NOT WITH_PROFILE)
   find_package(Tcmalloc)
-  set(LIBS ${LIBS} ${Tcmalloc_LIBRARIES})
-endif()
+  find_package(JeMalloc)
+  if(WITH_TCMALLOC AND Tcmalloc_FOUND)
+    set(LIBS ${LIBS} ${Tcmalloc_LIBRARIES})
+    set(MALLOC "TCMalloc")
+  elseif(WITH_JEMALLOC AND JEMALLOC_FOUND)
+    set(LIBS ${LIBS} ${JEMALLOC_LIBRARIES})
+    set(MALLOC "JEMalloc")
+  endif()
+endif()
+message(STATUS "The memory allocator: ${MALLOC}")
 
 # Find LibXML++ and dependencies.
 set(LIBXML++_MIN_VERSION "2.38.1")  # TODO: Fix the minimum version check.
@@ -161,7 +172,7 @@
 unset(Boost_INCLUDE_DIR CACHE)
 unset(Boost_LIBRARY_DIRS CACHE)
 find_package(Boost ${BOOST_MIN_VERSION} COMPONENTS
-  program_options filesystem system date_time
+  program_options filesystem system date_time random
   REQUIRED)
 
 if(Boost_USE_STATIC_LIBS)
@@ -208,6 +219,8 @@
 include_directories(SYSTEM "${LibXML++_INCLUDE_DIR}")
 include_directories(SYSTEM "${LibXML++Config_INCLUDE_DIR}")
 include_directories(SYSTEM ${Glibmm_INCLUDE_DIRS})  # TODO: libxml++ dependency.
+
+include_directories("${PROJECT_SOURCE_DIR}")  # Include the core headers via "src".
 
 add_subdirectory("${SCRAM_SOURCE_DIR}")
 add_subdirectory("${SCRAM_SHARE_DIR}")

=== gui/CMakeLists.txt ===
set(BUILD_SHARED_LIBS FALSE)  # GUI code should never be used by the core.

# Prevent implicit QString(const char*), string concat with "+", and other anti-patterns.
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_URL_CAST_FROM_STRING -DQT_USE_QSTRINGBUILDER")

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5)
    # TODO: Messes with override suggestions from QObject.
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-suggest-override")
  endif()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  # TODO: Qt moc offsetof applied to non-POD types is nonstandard.
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=1875")
endif()

if(Qt5Widgets_VERSION_STRING VERSION_EQUAL "5.7.0")
  set(CMAKE_CXX_STANDARD 14)  # TODO: Bug in CMake with Qt 5.7.0.
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set(SCRAM_GUI_RES "${CMAKE_CURRENT_SOURCE_DIR}/res.qrc")
set(SCRAM_GUI_SRC
  "${CMAKE_CURRENT_SOURCE_DIR}/mainwindow.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/event.cpp"
  )
set(SCRAM_GUI_BIN "${CMAKE_CURRENT_SOURCE_DIR}/main.cpp")
set(SCRAM_GUI_TS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/translations")

add_subdirectory("${SCRAM_GUI_TS_DIR}")

add_library(scramgui ${SCRAM_GUI_SRC} ${SCRAM_GUI_RES})

target_link_libraries(scramgui Qt5::Core Qt5::Gui Qt5::Widgets)

target_link_libraries(scramgui scramcore ${LIBS})

add_executable(scram-gui ${SCRAM_GUI_BIN})
target_link_libraries(scram-gui scramgui scramcore ${Boost_LIBRARIES})

install(TARGETS scram-gui
  RUNTIME DESTINATION bin
  COMPONENT gui
  )

set(SCRAM_GUI_TEST_DIR "${CMAKE_CURRENT_SOURCE_DIR}/tests")

if(BUILD_TESTS)
  add_subdirectory("${SCRAM_GUI_TEST_DIR}")
endif()

=== src/CMakeLists.txt ===
################### File Configurations #######################
execute_process(COMMAND git describe --tags OUTPUT_VARIABLE core_version
  OUTPUT_STRIP_TRAILING_WHITESPACE)
configure_file(version.cc.in "${CMAKE_CURRENT_SOURCE_DIR}/version.cc" @ONLY)

set(scram_install_dir "${CMAKE_INSTALL_PREFIX}")
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/env.cc.in"
  "${CMAKE_CURRENT_SOURCE_DIR}/env.cc"
  @ONLY
  )
################### End File Configurations ####################

set(LIB_LINK_FLAGS "")
if(WITH_COVERAGE)
  add_definitions("--coverage")
  set(LIB_LINK_FLAGS "--coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LIB_LINK_FLAGS}")
endif()

if(WITH_PROFILE)
  add_definitions("-pg")
endif()

set(SCRAM_CORE_SRC
  "${CMAKE_CURRENT_SOURCE_DIR}/env.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/version.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/error.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/logger.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/xml_stream.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/random.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/settings.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/config.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/cycle.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/element.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/expression.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/parameter.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/expression/constant.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/expression/arithmetic.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/expression/exponential.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/expression/random_deviate.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/event.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/ccf_group.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/fault_tree.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/model.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/boolean_graph.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/preprocessor.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/mocus.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bdd.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/zbdd.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/analysis.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/fault_tree_analysis.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/probability_analysis.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/importance_analysis.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/uncertainty_analysis.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/reporter.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/initializer.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/risk_analysis.cc"
  )
add_library(scramcore ${SCRAM_CORE_SRC})

if(INSTALL_LIBS)
  set_target_properties(scramcore
    PROPERTIES
    INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
    INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib"
    LINK_FLAGS "${LIB_LINK_FLAGS}"
    )
  if(WIN32)
    install(
      TARGETS scramcore
      RUNTIME DESTINATION bin COMPONENT scram
      LIBRARY DESTINATION lib COMPONENT scram
      ARCHIVE DESTINATION lib COMPONENT scram
      )
  else()
    install(
      TARGETS scramcore
      DESTINATION lib
      COMPONENT scram
      )
  endif()
endif()

target_link_libraries(scramcore ${LIBS})

add_executable(scram scram.cc)
target_link_libraries(scram scramcore ${Boost_LIBRARIES})

install(
  TARGETS scram
  RUNTIME DESTINATION bin
  COMPONENT scram
  )

=== tests/CMakeLists.txt ===
set(BUILD_SHARED_LIBS FALSE)  # No need to share with other executables.

# Exclude Debug warnings from the framework.
set(CURRENT_DEBUG_FLAGS "${CMAKE_CXX_FLAGS_DEBUG}")
set(CMAKE_CXX_FLAGS_DEBUG "-g")

set(GTEST_DIR  "${CMAKE_CURRENT_SOURCE_DIR}/googletest/googletest")

add_subdirectory("${GTEST_DIR}" EXCLUDE_FROM_ALL)

set(CMAKE_CXX_FLAGS_DEBUG "${CURRENT_DEBUG_FLAGS}")  # Restore the original flags.

include_directories(SYSTEM "${GTEST_DIR}/include")

# Include the project headers.
include_directories("${SCRAM_SOURCE_DIR}")

set(SCRAM_CORE_TEST_SOURCE
  "${CMAKE_CURRENT_SOURCE_DIR}/linear_map_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/xml_stream_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/settings_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/config_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/element_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/event_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/expression_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/ccf_group_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/fault_tree_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/boolean_graph_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/initializer_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/risk_analysis_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_core_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_two_train_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_lift_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_ne574_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_theatre_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_three_motor_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_200_event_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_small_tree_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_bscu_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_chinese_tree_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_baobab1_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_baobab2_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/bench_CEA9601_tests.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/performance_tests.cc"
  )

# Make tests switch and run in install directory.
configure_file(scram_unit_test_driver.cc.in
  "${CMAKE_CURRENT_SOURCE_DIR}/scram_unit_test_driver.cc"
  @ONLY
  )

add_executable(scram_tests
  scram_unit_test_driver.cc
  ${SCRAM_CORE_TEST_SOURCE}
  )

target_link_libraries(scram_tests
  ${LIBS}
  scramcore
  gtest
  )

install(
  TARGETS scram_tests
  RUNTIME DESTINATION bin
  COMPONENT testing
  )

# Copy test input files into the shared directory for testing.
install(DIRECTORY
  "${CMAKE_CURRENT_SOURCE_DIR}/input"
  DESTINATION share/scram
  COMPONENT testing
  )

=== debian/changelog ===
scram (0.11.5-1) unstable; urgency=medium

  * Update to new 0.11.5 upstream release
  * Remove the patch of CMakeLists.txt
    and use options provided in the new release
  * Use the man page from the doc directly
    (this had a typo in the previous release)

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Wed, 14 Dec 2016 00:27:41 -0800

=== debian/control ===
Source: scram
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Olzhas Rakhimov <ol.rakhimov@gmail.com>
Build-Depends: debhelper (>= 10),
               cmake (>= 2.8.12),
               libxml++2.6-dev (>= 2.38.1),
               libboost-all-dev (>= 1.56.0),
               libgoogle-perftools-dev
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/scram.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/scram.git
Homepage: http://scram-pra.org

Package: scram
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Probabilistic Risk Analysis Tool
 A command line probabilistic risk analysis tool
 capable of performing static fault tree analysis,
 analysis with common cause failure models,
 probability calculations with importance analysis,
 and uncertainty analysis with Monte Carlo simulations.

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,8 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
+		-DBUILD_SHARED_LIBS=OFF \
+		-DINSTALL_LIBS=OFF \
 		-DCMAKE_BUILD_TYPE=Release \
 		-DBUILD_GUI=OFF \
 		-DBUILD_TESTS=OFF

## scram 0.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,14 +13,14 @@
 
 project(SCRAM)
 set(SCRAM_VERSION_MAJOR 0)  # Indicate major API change after 1.0.0
-set(SCRAM_VERSION_MINOR 11)  # New features and improvements.
-set(SCRAM_VERSION_MICRO 5)  # Bug fixes.
+set(SCRAM_VERSION_MINOR 14)  # New features and improvements.
+set(SCRAM_VERSION_MICRO 0)  # Bug fixes.
 
 ####################### Begin Options ###################
 
 option(BUILD_SHARED_LIBS OFF)
 
-option(INSTALL_LIBS "Install the generated libraries" ON)
+option(INSTALL_LIBS "Install the generated libraries" ${BUILD_SHARED_LIBS})
 
 # Linking of external libraries, such as BOOST.
 option(WITH_STATIC_LIBS "Try to link against static libraries" OFF)
@@ -31,6 +31,8 @@
 option(WITH_COVERAGE "Instrument for coverage analysis" OFF)
 option(WITH_PROFILE "Instrument for performance profiling" OFF)
 
+option(HAS_TANGO "The system provides the fall-back Tango icons" OFF)
+
 option(BUILD_GUI "Build the GUI front-end" ON)
 option(BUILD_TESTS "Build the tests" ON)
 
@@ -41,34 +43,48 @@
 ####################### Begin compiler configurations ###################
 
 # Default to C++14.
-include(CheckCXXCompilerFlag)
-CHECK_CXX_COMPILER_FLAG("-std=c++1y" COMPILER_SUPPORTS_CXX14)
-if(NOT COMPILER_SUPPORTS_CXX14)
-  message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support.")
-endif()
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y")
+if(CMAKE_VERSION VERSION_LESS 3.1)
+  include(CheckCXXCompilerFlag)
+  CHECK_CXX_COMPILER_FLAG("-std=c++1y" COMPILER_SUPPORTS_CXX14)
+  if(NOT COMPILER_SUPPORTS_CXX14)
+    message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support.")
+  endif()
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y")
+else()
+  set(CMAKE_CXX_STANDARD 14)
+  set(CMAKE_CXX_STANDARD_REQUIRED ON)
+  set(CMAKE_CXX_EXTENSIONS OFF)
+endif()
+
+function(CHECK_COMPILER_VERSION MIN_VERSION)
+  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS MIN_VERSION)
+    message(FATAL_ERROR "${CMAKE_CXX_COMPILER_ID} Compiler version too old. Required minimum version: ${MIN_VERSION}")
+  endif()
+endfunction()
 
 set(CMAKE_CXX_FLAGS_DEBUG
   "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -Wno-sign-compare -Wnon-virtual-dtor -Wno-missing-field-initializers")
 
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wpedantic")
+  CHECK_COMPILER_VERSION("4.9")  # TODO: Wpedantic with gcc 4.9 errors with default arg lambdas.
   if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5)
-    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wshadow -Wsuggest-override")
-  endif()
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6)
-    # TODO: Boost sign bit shift fails to compile on GCC 6.1
-    add_definitions("-fpermissive")
-  endif()
-
-elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
-       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
+    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wshadow -Wpedantic")
+  endif()
+
+elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+  CHECK_COMPILER_VERSION("3.6")
   set(CMAKE_CXX_FLAGS_DEBUG
     "${CMAKE_CXX_FLAGS_DEBUG} -Wno-missing-braces -Wshadow -Wunused-exception-parameter")
 
-elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
-  # TODO: Bug in Intel compiler with multi-initialization with auto.
-  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=3373")
+elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
+  CHECK_COMPILER_VERSION("6.1")
+
+elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
+  CHECK_COMPILER_VERSION("17.0.1")
+  # TODO: CMAKE_CXX_STANDARD has no effect on icc.
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
+  # TODO: Bug in Intel compiler with multi-initialization with auto and final-is-not-override.
+  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=3373,1125")
 endif()
 
 if(WIN32)
@@ -104,10 +120,10 @@
   set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/bin")
 endif()
 if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
-  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib")
+  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib/scram")
 endif()
 if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
-  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib")
+  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib/scram")
 endif()
 
 set(SCRAM_EXECUTABLE_DIR "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
@@ -121,7 +137,7 @@
 set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
 
 if(INSTALL_LIBS)
-  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/scram")
 endif()
 
 # Add the automatically determined parts of the RPATH,
@@ -161,7 +177,7 @@
 # Include the boost header files and the program_options library.
 # Please be sure to use Boost rather than BOOST.
 # Capitalization matters on some platforms.
-set(BOOST_MIN_VERSION "1.56.0")
+set(BOOST_MIN_VERSION "1.58.0")
 set(Boost_USE_STATIC_LIBS ${WITH_STATIC_LIBS})
 set(Boost_USE_STATIC_RUNTIME ${WITH_STATIC_LIBS})
 
@@ -196,29 +212,16 @@
 set(LIBS ${LIBS} ${Boost_DATE_TIME_LIBRARY})
 message(STATUS "    Boost Date-Time location: ${Boost_DATE_TIME_LIBRARY}")
 
-if(BUILD_GUI)
-  # Find the QtWidgets library.
-  if(APPLE)
-    # Qt5 with Homebrew.
-    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "/usr/local/opt/qt5")
-  endif()
-  find_package(Qt5Widgets REQUIRED)
-  if(Qt5Widgets_FOUND)
-    message(STATUS "Found Qt5")
-    message(STATUS "Qt5 Version: ${Qt5Widgets_VERSION_STRING}")
-  endif()
-endif()
-
 ########################## End of find libraries ########################
 
 ########################## Begin includes ###############################
 
 # Include all the discovered system directories.
 include_directories(SYSTEM "${Boost_INCLUDE_DIR}")
-include_directories(SYSTEM "${LIBXML2_INCLUDE_DIR}")  # TODO: libxml++ dependency.
 include_directories(SYSTEM "${LibXML++_INCLUDE_DIR}")
 include_directories(SYSTEM "${LibXML++Config_INCLUDE_DIR}")
-include_directories(SYSTEM ${Glibmm_INCLUDE_DIRS})  # TODO: libxml++ dependency.
+include_directories(SYSTEM ${Glibmm_INCLUDE_DIRS})
+include_directories(SYSTEM "${LIBXML2_INCLUDE_DIR}")
 
 include_directories("${PROJECT_SOURCE_DIR}")  # Include the core headers via "src".
 
@@ -254,22 +257,35 @@
 if(PACKAGE)
   if(WIN32)
     set(CPACK_GENERATOR "NSIS")
-    # TODO: Find a way to programmatically detect shared libraries and add to installation.
+    # set(CPACK_PACKAGE_ICON "${PROJECT_SOURCE_DIR}\\\\gui\\\\images\\\\scram_logo.bmp")
+    set(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\scram-gui.exe")
+    set(CPACK_NSIS_MODIFY_PATH ON)
+    set(CPACK_NSIS_HELP_LINK "https://scram-pra.org")
+    set(CPACK_NSIS_URL_INFO_ABOUT "https://scram-pra.org")
+    set(CPACK_NSIS_CONTACT "scram-users@googlegroups.com")
+    set(CPACK_PACKAGE_EXECUTABLES "scram-gui" "SCRAM")
+    set(CPACK_CREATE_DESKTOP_LINKS "scram-gui")
+    set(CPACK_COMPONENT_GUI_REQUIRED ON)
     # The following configuration assumes MinGW64 is setup specifically for this project.
+    # Moreover, the Qt5 libs and plugins must be linked staticly,
+    # so there's no headache with implicit (undiscoverable) dependencies.
     get_filename_component(MINGW_DLL_DIR "${CMAKE_CXX_COMPILER}" PATH)
     message(STATUS "MinGW bin location: ${MINGW_DLL_DIR}")
-    file(GLOB all_libs "${MINGW_DLL_DIR}/lib*.dll")
+    include(GetPrerequisites)
+    get_prerequisites("${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/scram.exe"
+      SCRAM_ALL_PREREQUISITES 1 1 "" "")
+    message(STATUS "SCRAM dependency libs:\n${SCRAM_ALL_PREREQUISITES}")
+    foreach(item ${SCRAM_ALL_PREREQUISITES})
+      string(REGEX MATCH "scram" is_scram "${item}")
+      if(NOT is_scram)
+        gp_resolve_item("${MINGW_DLL_DIR}" "${item}" "" "" item)
+        list(APPEND SCRAM_PREREQUISITES ${item})
+      endif()
+    endforeach()
+    message(STATUS "SCRAM dependency libs resolution:\n${SCRAM_PREREQUISITES}")
+
     install(FILES
-      ${all_libs}
-      ${MINGW_DLL_DIR}/zlib1.dll
-      DESTINATION bin COMPONENT libraries
-    )
-
-    # Qt Libraries
-    install(FILES
-      ${MINGW_DLL_DIR}/Qt5Core.dll
-      ${MINGW_DLL_DIR}/Qt5Gui.dll
-      ${MINGW_DLL_DIR}/Qt5Widgets.dll
+      ${SCRAM_PREREQUISITES}
       DESTINATION bin COMPONENT libraries
     )
   endif()
@@ -282,6 +298,8 @@
 set(CPACK_PACKAGE_VERSION_PATCH "${SCRAM_VERSION_MICRO}")
 set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")
 
+set(CPACK_STRIP_FILES ON)
+
 set(CPACK_COMPONENTS_ALL scram libraries gui examples)
 set(CPACK_COMPONENT_SCRAM_REQUIRED ON)
 set(CPACK_COMPONENT_LIBRARIES_REQUIRED ON)

=== gui/CMakeLists.txt ===
# Find the QtWidgets library.
if(APPLE)
  # Qt5 with Homebrew.
  set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "/usr/local/opt/qt5")
endif()
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5OpenGL REQUIRED)
find_package(Qt5PrintSupport REQUIRED)
find_package(Qt5Concurrent REQUIRED)
message(STATUS "Found Qt5")
message(STATUS "Qt5 Version: ${Qt5Widgets_VERSION_STRING}")

# Prevent implicit QString(const char*), string concat with "+", and other anti-patterns.
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_URL_CAST_FROM_STRING -DQT_USE_QSTRINGBUILDER")

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  # TODO: Qt moc offsetof applied to non-POD types is nonstandard.
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=1875")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  if(Qt5Widgets_VERSION_STRING VERSION_LESS 5.4)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-inconsistent-missing-override")
  endif()
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# TODO: Use the autogeneration for static Qt plugin linking by CMake (buggy as of Qt 5.8).
# if(WIN32)
#   set(CMAKE_AUTOSTATICPLUGINS ON)  # Special mingw64 cmake extension.
# endif()

set(SCRAM_GUI_RES "${CMAKE_CURRENT_SOURCE_DIR}/res.qrc")

if(NOT HAS_TANGO AND (WIN32 OR APPLE))
  set(TANGO_QRC "${CMAKE_CURRENT_SOURCE_DIR}/qtango/icons/tango/tango.qrc")
  execute_process(
    COMMAND python generate_rcc.py icons/tango/index.theme
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/qtango"
    RESULT_VARIABLE qtango_return
    OUTPUT_VARIABLE qtango_out
    ERROR_VARIABLE qtango_out
    )
  if(qtango_return)
    message(FATAL_ERROR "Tango icon generation failed: ${qtango_out}")
  endif()
  list(APPEND SCRAM_GUI_RES "${TANGO_QRC}")
endif()

set(SCRAM_GUI_SRC
  "${CMAKE_CURRENT_SOURCE_DIR}/model.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/modeltree.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/elementcontainermodel.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/settingsdialog.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/eventdialog.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/printable.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/zoomableview.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/diagram.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/mainwindow.cpp"
  "${CMAKE_CURRENT_SOURCE_DIR}/scramgui.cpp"
  )
set(SCRAM_GUI_TS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/translations")

add_subdirectory("${SCRAM_GUI_TS_DIR}")

add_library(scramgui ${SCRAM_GUI_SRC} ${SCRAM_GUI_RES})
set(GUI_DEP_LIBS  # TODO: Link with shared libraries on Windows instead.
  ${LIBS} scramcore
  Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Svg Qt5::OpenGL Qt5::PrintSupport Qt5::Concurrent)

if(INSTALL_LIBS)
  if(WIN32)
    target_link_libraries(scramgui PRIVATE ${GUI_DEP_LIBS})  # TODO: Remove.
    install(TARGETS scramgui RUNTIME DESTINATION bin COMPONENT gui)
  else()
    target_link_libraries(scramgui ${GUI_DEP_LIBS})  # TODO: Make default.
    set_target_properties(scramgui
      PROPERTIES
      INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib/scram"
      INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/scram"
      )
    install(
      TARGETS scramgui
      DESTINATION lib/scram
      COMPONENT gui
      )
  endif()
endif()

if(WIN32)
  add_executable(scram-gui WIN32
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/scram.rc")
else()
  add_executable(scram-gui "${CMAKE_CURRENT_SOURCE_DIR}/main.cpp")
endif()
target_link_libraries(scram-gui scramgui)

install(TARGETS scram-gui
  RUNTIME DESTINATION bin
  COMPONENT gui
  )

if(UNIX AND NOT APPLE)
  foreach (size IN ITEMS 32 128)
    install(
      FILES       "${CMAKE_CURRENT_SOURCE_DIR}/images/scram_solid${size}x${size}.png"
      DESTINATION "share/icons/hicolor/${size}x${size}/apps"
      COMPONENT gui
      RENAME      "scram.png")
  endforeach ()
  install(
    FILES       "${CMAKE_CURRENT_SOURCE_DIR}/images/scram_solid.svg"
    DESTINATION "share/icons/hicolor/scalable/apps"
    COMPONENT gui
    RENAME      "scram.svg")

  # Install a desktop file
  # so that SCRAM appears in the application start menu with an icon.
  install(FILES scram-gui.desktop
    DESTINATION "share/applications"
    COMPONENT gui)
endif()

set(SCRAM_GUI_TEST_DIR "${CMAKE_CURRENT_SOURCE_DIR}/tests")

if(BUILD_TESTS AND NOT WIN32)
  add_subdirectory("${SCRAM_GUI_TEST_DIR}")
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -13,13 +13,11 @@
 
 set(LIB_LINK_FLAGS "")
 if(WITH_COVERAGE)
-  add_definitions("--coverage")
-  set(LIB_LINK_FLAGS "--coverage")
-  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LIB_LINK_FLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
 endif()
 
 if(WITH_PROFILE)
-  add_definitions("-pg")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
 endif()
 
 set(SCRAM_CORE_SRC
@@ -31,19 +29,21 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/random.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/settings.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/config.cc"
-  "${CMAKE_CURRENT_SOURCE_DIR}/cycle.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/element.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/expression.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/parameter.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/expression/conditional.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/expression/constant.cc"
-  "${CMAKE_CURRENT_SOURCE_DIR}/expression/arithmetic.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/expression/numerical.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/expression/exponential.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/expression/random_deviate.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/expression/test_event.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/event.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/ccf_group.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/fault_tree.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/event_tree.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/model.cc"
-  "${CMAKE_CURRENT_SOURCE_DIR}/boolean_graph.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/pdag.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/preprocessor.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/mocus.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bdd.cc"
@@ -53,30 +53,26 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/probability_analysis.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/importance_analysis.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/uncertainty_analysis.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/event_tree_analysis.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/reporter.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/serialization.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/initializer.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/risk_analysis.cc"
   )
 add_library(scramcore ${SCRAM_CORE_SRC})
 
 if(INSTALL_LIBS)
-  set_target_properties(scramcore
-    PROPERTIES
-    INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
-    INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib"
-    LINK_FLAGS "${LIB_LINK_FLAGS}"
-    )
   if(WIN32)
+    install(TARGETS scramcore RUNTIME DESTINATION bin COMPONENT scram)
+  else()
+    set_target_properties(scramcore
+      PROPERTIES
+      INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib/scram"
+      INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/scram"
+      )
     install(
       TARGETS scramcore
-      RUNTIME DESTINATION bin COMPONENT scram
-      LIBRARY DESTINATION lib COMPONENT scram
-      ARCHIVE DESTINATION lib COMPONENT scram
-      )
-  else()
-    install(
-      TARGETS scramcore
-      DESTINATION lib
+      DESTINATION lib/scram
       COMPONENT scram
       )
   endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -25,9 +25,10 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/expression_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/ccf_group_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/fault_tree_tests.cc"
-  "${CMAKE_CURRENT_SOURCE_DIR}/boolean_graph_tests.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/pdag_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/initializer_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/risk_analysis_tests.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/serialization_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_core_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_two_train_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_lift_tests.cc"
@@ -41,6 +42,9 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_baobab1_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_baobab2_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_CEA9601_tests.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/bench_hipps_tests.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/bench_attack.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/bench_gas_leak.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/performance_tests.cc"
   )

=== debian/changelog ===
scram (0.14.0-1) unstable; urgency=medium

  * New upstream 0.14.0
  * Configure GUI dependencies (Qt5)
  * Boost min version bump to 1.58
  * Generate man page with help2man (manually, ironically :)
  * Standards version bump to 4.0.1
  * Bump the copyright year to 2017
  * New 'scram-gui' binary
  * Configure the packaging for multi-binary (separate & explicit install)
  * Use 'dh-exec' to rename 'scram.sh' to 'scram' upon installation
  * Override 'dh_install' to warn missing installations

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Mon, 31 Jul 2017 19:38:57 -0700

=== debian/control ===
Source: scram
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Olzhas Rakhimov <ol.rakhimov@gmail.com>
Build-Depends: debhelper (>= 10),
               dh-exec,
               cmake (>= 2.8.12),
               libxml++2.6-dev (>= 2.38.1),
               libboost-all-dev (>= 1.58.0),
               libgoogle-perftools-dev,
               qtbase5-dev (>= 5.2.1),
               qtbase5-dev-tools,
               libqt5svg5-dev,
               libqt5opengl5-dev
Standards-Version: 4.0.1
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/scram.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/scram.git
Homepage: https://scram-pra.org

Package: scram
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Probabilistic Risk Analysis Tool
 A command line probabilistic risk analysis tool
 capable of performing event tree analysis,
 static fault tree analysis,
 analysis with common cause failure models,
 probability calculations with importance analysis,
 and uncertainty analysis with Monte Carlo simulations.

Package: scram-gui
Architecture: any
Depends: scram, ${shlibs:Depends}, ${misc:Depends}
Description: SCRAM GUI front-end
 The complementary SCRAM GUI front-end
 for visualization and manipulation
 of risk anlysis models and reports.
